]> git.pld-linux.org Git - packages/rpm-build-macros.git/blame_incremental - macros.pld
Add rename notice
[packages/rpm-build-macros.git] / macros.pld
... / ...
CommitLineData
1# vim:ts=4 sw=4 noet ft=spec
2#
3# PLD Linux rpm macros.
4# <http://www.pld-linux.org/>
5
6# can be used by builder script to check for version
7%rpm_build_macros {Revision}
8
9%epoch 0
10%x8664 x86_64 amd64 ia32e
11
12# compiler version
13%cc_version %{expand:%%global cc_version %(%{__cc} -dumpversion 2>/dev/null || echo 0.0)}%cc_version
14%cxx_version %{expand:%%global cxx_version %(%{__cxx} -dumpversion 2>/dev/null || echo 0.0)}%cxx_version
15
16%__rm /bin/rm --interactive=never
17
18# Build system path macros.
19%__autoconf autoconf %{?debug:-Wall}
20%__automake automake -a -c -f --foreign
21%__autopoint autopoint --force
22
23# add parallel build flags: -jN
24# jobs macro is available since 1.657
25#
26# if you want to disable parallel build do:
27# echo '%__jobs %{nil}' >> ~/.rpmmacros
28%__jobs %{expand:%%global __jobs %(_NCPUS=$(/usr/bin/getconf _NPROCESSORS_ONLN); [ "$_NCPUS" -gt 3 ] && echo $(($_NCPUS / 2)))%%{nil}}%__jobs
29
30# expands to -jN if %__jobs has a value
31%_smp_mflags %{expand:%%global _smp_mflags %(jobs=%{__jobs}; echo ${jobs:+-j$jobs}%%{nil})}%_smp_mflags
32
33%__make /usr/bin/make %{?_make_opts} %{?_smp_mflags}
34%__scons /usr/bin/scons %{?_smp_mflags}
35%__waf /usr/bin/waf %{?_smp_mflags}
36%__cmake /usr/bin/cmake -Wno-dev
37%__meson /usr/bin/meson
38%__meson_wrap_mode nodownload
39%__ninja /usr/bin/ninja
40%__ninja_common_opts -v %{?_smp_mflags}
41
42%__gettextize { \
43 gettextize --copy --force --no-changelog; \
44 if [ ! -f po/Makevars ]; then \
45 cp -f po/Makevars{.template,}; \
46 fi; \
47}
48
49%__glib_gettextize glib-gettextize --copy --force
50%__gnome_doc_common gnome-doc-common --copy
51%__gnome_doc_prepare gnome-doc-prepare --copy --force
52%__gtkdocize gtkdocize --copy
53%__intltoolize intltoolize --copy --force
54%__libtoolize libtoolize --copy --force --install
55
56# topdir is where builder script lives,
57# fallback to old style if SPECS/SOURCES dirs were found.
58%_topdir %{expand:%%global _topdir %(
59 if [ -d SPECS -a -d SOURCES ]; then
60 # old style rpmdir: in topdir
61 pwd
62 elif [ -d ../SPECS -a -d ../SOURCES ]; then
63 # old style rpmdir: in subdir
64 cd ..; pwd
65 elif [ -d $HOME/rpm/SPECS -a -d $HOME/rpm/SOURCES ]; then \
66 # if old style rpm dir exist, go with it
67 echo $HOME/rpm; \
68 elif [ -x ../builder -a ! -d ../builder ]; then
69 # relative new style rpmdir: in package dir
70 cd ..; pwd
71 elif [ -x builder -a ! -d builder ]; then
72 # relative new style rpmdir: in packages
73 pwd
74 elif [ -x packages/builder -a ! -d packages/builder ]; then
75 # relative new style rpmdir: packages dir in current dir
76 cd packages; pwd
77 else
78 # fallback to new style rpmdir
79 echo $HOME/rpm/packages
80 fi; \
81)}%_topdir
82
83# if %{_topdir}/SPECS exists, it's old style structure
84%_specdir %{expand:%%global _specdir %([ ! -d %{_topdir}/SPECS ] && echo %{_topdir}/%{name} || echo %{_topdir}/SPECS)}%_specdir
85%_sourcedir %{expand:%%global _sourcedir %([ ! -d %{_topdir}/SOURCES ] && echo %{_specdir} || echo %{_topdir}/SOURCES)}%_sourcedir
86
87# BUILD/RPMS/SRPMS are on same level by default as packages dir, if these exist
88# if they don't exist assume we are having custom topdir (which is not named as
89# "packages", i.e ~/rpm/kde/{kdelibs,BUILD/RPMS/SRPMS})
90# NOTE: readlink fails if some parent dir is not readable (/home/services/builder for example can't read /home/services), therefore the extra echo
91%_builddir %{expand:%%global _builddir %(if [ -d %{_topdir}/BUILD ]; then echo %{_topdir}/BUILD; else readlink -m %{_topdir}/../BUILD || echo %{_topdir}/../BUILD; fi)}%_builddir
92%_rpmdir %{expand:%%global _rpmdir %(if [ -d %{_topdir}/RPMS ]; then echo %{_topdir}/RPMS; else readlink -m %{_topdir}/../RPMS || echo readlink -m %{_topdir}/../RPMS; fi)}%_rpmdir
93%_srcrpmdir %{expand:%%global _srcrpmdir %(if [ -d %{_topdir}/SRPMS ]; then echo %{_topdir}/SRPMS; else readlink -m %{_topdir}/../SRPMS || echo readlink -m %{_topdir}/../SRPMS; fi)}%_srcrpmdir
94
95# The number of cvs changelog entries kept when building package.
96%_buildchangelogtruncate 20
97
98%dependencytracking %{nil}
99
100# Relations between package names that cause dependency loops
101# with legacy packages that cannot be fixed. Relations are
102# specified as
103# p>q
104# where package p has a Requires: on something that package q Provides:
105#
106# XXX Note: that there cannot be any whitespace within the string "p>q",
107# and that both p and q are package names (i.e. no version/release).
108%_dependency_whiteout %{nil}
109
110#-----------------------------------------------------------------
111#
112# (re)definition of %{rpm*flags} with %filterout_* support
113# BuildRequires: awk
114# BuildRequires: rpmbuild(macros) >= 1.315
115#
116# Flags specified in %filterout_* are removed from %rpm*flags, exactly:
117# %rpmcflags = %optflags - %filterout - %filterout_c - %filterout_ld
118# %rpmcxxflags = %optflags - %filterout - %filterout_cxx - %filterout_ld
119# %rpmcppflags = %optcppflags - %filterout - %filterout_cpp - %filterout_ld
120# %rpmldflags = %optldflags - %filterout_ld
121#
122# Regular expressions are supported, but to avoid some character be treated
123# as regular expression it must be escaped twice.
124
125%filter_out \
126 for (i = 1; i in I; i++) { A=0; \
127 for (f in F) { \
128 if (I[i] ~ "^" F[f] "$") A=1; \
129 }; \
130 if (!A) printf(I[i] FS); \
131 }
132
133%rpmcflags %(awk 'BEGIN {
134 split("%{?debug:%debugcflags}%{!?debug:%optflags}%{?debuginfocflags}",I);
135 split("%{?filterout} %{?filterout_c} %{?filterout_ld}",F);
136 %{filter_out}
137}')
138
139%rpmcxxflags %(awk 'BEGIN {
140 split("%{?debug:%debugcflags}%{!?debug:%optflags}%{?debuginfocflags}",I);
141 split("%{?filterout} %{?filterout_cxx} %{?filterout_ld}",F);
142 %{filter_out}
143}')
144
145%rpmcppflags %(awk 'BEGIN {
146 split("%{?debug:%debugcppflags}%{!?debug:%optcppflags}%{?debuginfocppflags}",I);
147 split("%{?filterout} %{?filterout_cpp} %{?filterout_cpp}",F);
148 %{filter_out}
149}')
150
151%rpmldflags %(awk 'BEGIN {
152 split("%{?optldflags}",I);
153 split("%{?filterout_ld}",F)
154 %{filter_out}
155}')
156
157# rpmldflags with stripped -Wl, -- in the form flags have to be passed to 'ld'
158# but, don't use it, better use gcc as linker
159%ld_rpmldflags %(awk 'BEGIN {
160 split("%{rpmldflags}",F);
161 for (f in F) {
162 s = F[f];
163 if (s ~ /^-Wl,/) {
164 s = substr(s,5);
165 gsub(/,/," ",s);
166 };
167 printf(s FS);
168 };
169}')
170
171#-----------------------------------------------------------------
172#
173# Generate a command which cleans environment, leaving only the
174# most important variables.
175# If any spec requires any additional environment it should
176# redefine %_preserve_env in following manner:
177#
178# # ADDITIONAL_VAR is required because [a good reason here]
179# %define _preserve_env ADDITIONAL_VAR
180
181%_preserve_env_base PATH HOME TMP TMPDIR SSH_AUTH_SOCK
182
183# "env -i" must end in first line of expaned macros because it's used as first line of shell script (#! env...)
184%_clean_env env -i %(awk -vq="'" -vqq="\\"'\\"" -vq2q="'\\"'" 'BEGIN {
185 split("%{?_preserve_env:%_preserve_env %_preserve_env_base}%{!?_preserve_env:%_preserve_env_base}", P);
186 for (i in P) {
187 p = P[i];
188 if (!ENVIRON[p] || d[p]) {
189 continue;
190 }
191 d[p] = 1;
192 split(ENVIRON[p], V, "");
193 val = p "=";
194 for (j = 1; j in V; j++) {
195 v = V[j];
196 if (v == q)
197 v = qq;
198 else if (v == "\\"")
199 v = q2q;
200 else if (v == "\\\\")
201 v = "\\\\\\\\";
202 else
203 gsub("[^a-zA-Z0-9/:._-]", "\\"&\\"", v);
204 val = val "" v;
205 }
206 printf(val " ");
207 }
208}')
209
210# override %__spec_build_pre and %__spec_install_pre from macros.rpmbuild
211# adding %{_clean_env}
212%__spec_build_pre %{_clean_env}\
213%{___build_pre}\
214%{nil}
215%__spec_install_pre %{_clean_env}\
216%{___build_pre}\
217%{?buildroot:%{__rm} -rf '%{buildroot}'; %{__mkdir_p} '%{buildroot}'}\
218%{nil}
219
220#-----------------------------------------------------------------
221%configure2_13 { \
222 if [ -n "$LINGUAS" ]; then unset LINGUAS; fi; \
223 LDFLAGS="${LDFLAGS:-%rpmldflags}" ; export LDFLAGS ; \
224 CFLAGS="${CFLAGS:-%rpmcflags}" ; export CFLAGS ; \
225 CXXFLAGS="${CXXFLAGS:-%rpmcxxflags}" ; export CXXFLAGS ; \
226 FFLAGS="${FFLAGS:-%rpmcflags}" ; export FFLAGS ; \
227 FCFLAGS="${FCFLAGS:-%rpmcflags}" ; export FCFLAGS ; \
228 CPPFLAGS="${CPPFLAGS:-%rpmcppflags}" ; export CPPFLAGS ; \
229 %{?__cc:CC="%{__cc}" ; export CC ; } \
230 %{?__cxx:CXX="%{__cxx}" ; export CXX ; } \
231 %{?configuredir:%{configuredir}}%{!?configuredir:.}/configure \
232 --host=%{_target_platform} \
233 --prefix=%{_prefix} \
234 --exec-prefix=%{_exec_prefix} \
235 --bindir=%{_bindir} \
236 --sbindir=%{_sbindir} \
237 --sysconfdir=%{_sysconfdir} \
238 --datadir=%{_datadir} \
239 --includedir=%{_includedir} \
240 --libdir=%{_libdir} \
241 --libexecdir=%{_libexecdir} \
242 --localstatedir=%{_localstatedir} \
243 --sharedstatedir=%{_sharedstatedir} \
244 --mandir=%{_mandir} \
245 --infodir=%{_infodir} \
246 --x-libraries=%{?_x_libraries}%{!?_x_libraries:%{_libdir}} \
247 %{dependencytracking} \
248}
249
250# Note: pass only standard cmake macros here.
251# The only exception is SYSCONF_INSTALL_DIR, used commonly in KDE packages,
252# where the default (${CMAKE_INSTALL_PREFIX}/etc) is not FHS-compliant and
253# absolute path MUST be used to comply with FHS.
254# The other non-standard cmake macros used commonly in KDE
255# (INCLUDE_INSTALL_DIR, LIB_INSTALL_DIR, SHARE_INSTALL_PREFIX)
256# have sane default values in KDE, and some packages use these names
257# in different way (e.g. expect them to be always relative or always
258# absolute).
259%cmake \
260%{?__cc:CC="${CC:-%{__cc}}"} \\\
261%{?__cxx:CXX="${CXX:-%{__cxx}}"} \\\
262CPPFLAGS="${CPPFLAGS:-%{rpmcppflags}}" \\\
263%{__cmake} \\\
264 -DCMAKE_VERBOSE_MAKEFILE=ON \\\
265 -DCMAKE_BUILD_TYPE=%{!?debug:PLD}%{?debug:Debug} \\\
266 -DCMAKE_INSTALL_BINDIR:PATH=%{_bindir} \\\
267 -DCMAKE_INSTALL_SBINDIR:PATH=%{_sbindir} \\\
268 -DCMAKE_INSTALL_LIBEXECDIR:PATH=%{_libexecdir} \\\
269 -DCMAKE_INSTALL_SYSCONFDIR:PATH=%{_sysconfdir} \\\
270 -DCMAKE_INSTALL_SHAREDSTATEDIRPATH:PATH=%{_sharedstatedir} \\\
271 -DCMAKE_INSTALL_LOCALSTATEDIRPATH:PATH=%{_localstatedir} \\\
272 -DCMAKE_INSTALL_LIBDIR:PATH=%{_libdir} \\\
273 -DCMAKE_INSTALL_INCLUDEDIR:PATH=%{_includedir} \\\
274 -DCMAKE_INSTALL_OLDINCLUDEDIR:PATH=%{_includedir} \\\
275 -DCMAKE_INSTALL_DATAROOTDIR:PATH=%{_datadir} \\\
276 -DCMAKE_INSTALL_DATADIR:PATH=%{_datadir} \\\
277 -DCMAKE_INSTALL_INFODIR:PATH=%{_infodir} \\\
278 -DCMAKE_INSTALL_LOCALEDIR:PATH=%{_localedir} \\\
279 -DCMAKE_INSTALL_MANDIR:PATH=%{_mandir} \\\
280 -DCMAKE_INSTALL_DOCDIR:PATH=%{_docdir} \\\
281 -DCMAKE_INSTALL_PREFIX:PATH=%{_prefix} \\\
282 -DSYSCONF_INSTALL_DIR:PATH=%{_sysconfdir} \\\
283 -DCMAKE_CXX_FLAGS_PLD="${CXXFLAGS:-%{rpmcxxflags} -DNDEBUG -DQT_NO_DEBUG}" \\\
284 -DCMAKE_C_FLAGS_PLD="${CFLAGS:-%{rpmcflags} -DNDEBUG -DQT_NO_DEBUG}" \\\
285 -DCMAKE_Fortran_FLAGS_PLD="${CFLAGS:-%{rpmcflags} -DNDEBUG -DQT_NO_DEBUG}" \\\
286 -DCMAKE_EXE_LINKER_FLAGS_PLD="${LDFLAGS:-%{rpmldflags}}" \\\
287 -DCMAKE_SHARED_LINKER_FLAGS_PLD="${LDFLAGS:-%{rpmldflags}}" \\\
288 -DCMAKE_MODULE_LINKER_FLAGS_PLD="${LDFLAGS:-%{rpmldflags}}" \\\
289%if "%{_lib}" == "lib64" \
290 -DLIB_SUFFIX=64 \\\
291%endif \
292%if "%{_lib}" == "libx32" \
293 -DLIB_SUFFIX=x32 \\\
294%endif \
295 -DBUILD_SHARED_LIBS:BOOL=ON \\\
296%{nil}
297
298%scons { \
299%{__scons} \
300 LDFLAGS="${LDFLAGS:-%rpmldflags}" \
301 CFLAGS="${CFLAGS:-%rpmcflags}" \
302 CXXFLAGS="${CXXFLAGS:-%rpmcxxflags}" \
303 FFLAGS="${FFLAGS:-%rpmcflags}" \
304 CPPFLAGS="${CPPFLAGS:-%rpmcppflags}" \
305 %{?__cc:CC="%{__cc}"} \
306 %{?__cxx:CXX="%{__cxx}"} \
307 libsuffix=%{_lib} \
308 prefix=%{_prefix} \
309}
310
311# waf. see waf.spec
312%waf { \
313CC="%{__cc}" \
314CXX="%{__cxx}" \
315CPP="%{__cpp}" \
316CFLAGS="%{rpmcflags}" \
317CXXFLAGS="%{rpmcxxflags}" \
318LINKFLAGS="%{rpmldflags}" \
319%{__waf} \
320}
321
322# meson
323%meson { \
324%{?__cc:CC="${CC:-%{__cc}}"} \
325%{?__cxx:CXX="${CXX:-%{__cxx}}"} \
326CFLAGS="${CFLAGS:-%{rpmcflags}}" \
327CPPFLAGS="${CPPFLAGS:-%{rpmcppflags}}" \
328CXXFLAGS="${CXXFLAGS:-%{rpmcxxflags}}" \
329LDFLAGS="${LDFLAGS:-%{rpmldflags}}" \
330LC_ALL=C.UTF-8 %{__meson} \
331 --buildtype=plain \
332 --bindir=%{_bindir} \
333 --datadir=%{_datadir} \
334 --includedir=%{_includedir} \
335 --infodir=%{_infodir} \
336 --libdir=%{_libdir} \
337 --libexecdir=%{_libexecdir} \
338 --localedir=%{_localedir} \
339 --localstatedir=%{_localstatedir} \
340 --mandir=%{_mandir} \
341 --prefix=%{_prefix} \
342 --sbindir=%{_sbindir} \
343 --sharedstatedir=%{_sharedstatedir} \
344 --sysconfdir=%{_sysconfdir} \
345 --wrap-mode=%{__meson_wrap_mode} \
346 --default-library='both' \
347}
348
349%___meson_deprecate() {echo >&2 "DEPRECATED: %%%1 must be replaced with %%%2"; %{expand:%%%2} }
350%meson_build %___meson_deprecate meson_build ninja_build
351%meson_install %___meson_deprecate meson_install ninja_install
352%meson_test %___meson_deprecate meson_test ninja_test
353
354# ninja
355%ninja_build LC_ALL=C.UTF-8 %{__ninja} %{__ninja_common_opts}
356%ninja_install LC_ALL=C.UTF-8 DESTDIR=%{buildroot} %{__ninja} install %{__ninja_common_opts}
357%ninja_test LC_ALL=C.UTF-8 %{__ninja} test %{__ninja_common_opts}
358
359#----------------------------------------------------------------
360#%configure_cache 0
361%configure_cache_file %{buildroot}.configure.cache
362
363%configure {./configure \
364 LDFLAGS="${LDFLAGS:-%rpmldflags}" \
365 CFLAGS="${CFLAGS:-%rpmcflags}" \
366 CXXFLAGS="${CXXFLAGS:-%rpmcxxflags}" \
367 FFLAGS="${FFLAGS:-%rpmcflags}" \
368 FCFLAGS="${FCFLAGS:-%rpmcflags}" \
369 CPPFLAGS="${CPPFLAGS:-%rpmcppflags}" \
370 %{?__cc:CC="%{__cc}"} \
371 %{?__cxx:CXX="%{__cxx}"} \
372 --host=%{_target_platform} \
373 --build=%{_target_platform} \
374 --prefix=%{_prefix} \
375 --exec-prefix=%{_exec_prefix} \
376 --bindir=%{_bindir} \
377 --sbindir=%{_sbindir} \
378 --sysconfdir=%{_sysconfdir} \
379 --datadir=%{_datadir} \
380 --includedir=%{_includedir} \
381 --libdir=%{_libdir} \
382 --libexecdir=%{_libexecdir} \
383 --localstatedir=%{_localstatedir} \
384 --sharedstatedir=%{_sharedstatedir} \
385 --mandir=%{_mandir} \
386 --infodir=%{_infodir} \
387 --x-libraries=%{?_x_libraries}%{!?_x_libraries:%{_libdir}} \
388 %{dependencytracking} \
389 %{?configure_cache:--cache-file=%{configure_cache_file}} \
390}
391
392# Simple macros to simplify adding bconded options to configure scripts.
393# Each macro requires bcond name and accepts optional option name, if option
394# isn't specified bcond name is used as option name. Options returning
395# --with and --enable also allow third argument which will be added as value
396# ( --with-option=value or --enable-option=value ) in case or positive
397# condition, but won't be added otherwise ( nothing or just --disable-option ).
398
399# Requirements:
400# BuildRequires: rpmbuild(macros) >= 1.527
401
402# Usage example:
403# %{__enable bcond} - returns --enable-bcond iff build condition is set
404# %{__disable bcond option} - returns --enable-option iff bcond is not set
405# %{__enable_disable bcond option value} - returns --enable-option=value if
406# bcond is set, returns --disable-option otherwise
407
408# expand bconds to --enable-something and --disable-something
409%__enable() %{expand:%%{?with_%{1}:--enable-%{?2}%{!?2:%{1}}%{?3:=%{3}}}}
410%__disable() %{expand:%%{!?with_%{1}:--disable-%{?2}%{!?2:%{1}}}}
411%__enable_disable() %{expand:%%{?with_%{1}:--enable-%{?2}%{!?2:%{1}}%{?3:=%{3}}}%%{!?with_%{1}:--disable-%{?2}%{!?2:%{1}}}}
412
413# same as above, but condition inverted
414%__enable_unless() %{expand:%%{!?with_%{1}:--enable-%{?2}%{!?2:%{1}}%{?3:=%{3}}}}
415%__disable_if() %{expand:%%{?with_%{1}:--disable-%{?2}%{!?2:%{1}}}}
416%__enable_disable_not() %{expand:%%{!?with_%{1}:--enable-%{?2}%{!?2:%{1}}%{?3:=%{3}}}%%{?with_%{1}:--disable-%{?2}%{!?2:%{1}}}}
417
418# expand bconds to --with-something and --without-something
419%__with() %{expand:%%{?with_%{1}:--with-%{?2}%{!?2:%{1}}%{?3:=%{3}}}}
420%__without() %{expand:%%{!?with_%{1}:--without-%{?2}%{!?2:%{1}}}}
421%__with_without() %{expand:%%{?with_%{1}:--with-%{?2}%{!?2:%{1}}%{?3:=%{3}}}%%{!?with_%{1}:--without-%{?2}%{!?2:%{1}}}}
422
423# same as above, but condition inverted
424%__with_unless() %{expand:%%{!?with_%{1}:--with-%{?2}%{!?2:%{1}}%{?3:=%{3}}}}
425%__without_if() %{expand:%%{?with_%{1}:--without-%{?2}%{!?2:%{1}}}}
426%__with_without_not() %{expand:%%{!?with_%{1}:--with-%{?2}%{!?2:%{1}}%{?3:=%{3}}}%%{?with_%{1}:--without-%{?2}%{!?2:%{1}}}}
427
428# expands to true or false based on bcond; for use with meson or cmake
429%__true_false() %{expand:%%{?with_%{1}:true}%%{!?with_%{1}:false}}
430%__true_false_not() %{expand:%%{?with_%{1}:false}%%{!?with_%{1}:true}}
431
432# for use with cmake:
433# Usage: cmake_on_off BCOND_NAME [OPTION_NAME]
434# BuildRequires: rpmbuild(macros) >= 1.742
435%cmake_on_off() -D%{?2}%{!?2:%{1}}:BOOL=%{expand:%%{?with_%{1}:ON}%%{!?with_%{1}:OFF}}
436
437#-----------------------------------------------------------------
438
439# overload to insert debuginfo package
440%prep \
441%if 0%{?_enable_debug_packages}\
442%{debug_package}\
443%endif\
444%%prep\
445%{nil}
446
447# Location of autoconf macros
448%_aclocaldir %{expand:%%global _aclocaldir %(aclocal --print-ac-dir 2>/dev/null || echo ERROR)}%_aclocaldir
449
450# Location of omf files
451%_omf_dest_dir %{expand:%%global _omf_dest_dir %(scrollkeeper-config --omfdir || echo ERROR)}%_omf_dest_dir
452
453# Location of pkgconfig files
454%_pkgconfigdir /usr/%{_lib}/pkgconfig
455# noarch pkgconfig files
456%_npkgconfigdir /usr/share/pkgconfig
457
458# Location of desktop files
459%_desktopdir /usr/share/applications
460%_applnkdir ERROR:_applnkdir_is_obsolete_use_desktopdir_instead
461
462# Location of pixmaps for applnk/desktop files
463%_pixmapsdir /usr/share/pixmaps
464
465# Location of themable icons for applnk/desktop files
466%_iconsdir /usr/share/icons
467
468# Location of fonts directories
469%_fontsdir /usr/share/fonts
470
471# Location of Gtk and associated libraries documentation
472%_gtkdocdir %{_defaultdocdir}/gtk-doc/html
473
474# Location of KDE documentation
475%_kdedocdir %{_defaultdocdir}/kde/HTML
476
477# unsermake script
478%__unsermake /usr/share/unsermake/unsermake
479
480# Current date
481%date %(LC_ALL=C date +"%a %b %d %Y")
482
483# Example files, programs, scripts...
484%_examplesdir /usr/src/examples
485
486# SysV-style initscripts dir
487%_initddir /etc/rc.d/init.d
488
489# If non-empty "debug" macro defined, add "dbg" suffix to release number
490%_rpmfilename %%{NAME}-%%{VERSION}-%%{RELEASE}%{?debug:dbg}.%%{ARCH}.rpm
491
492# Bootstrap release macros.
493# Usage:
494# %bcond_with bootstrap
495# Release: %{bootstrap_release 1}
496#
497# Package will have release 1 if built normally,
498# and release 0.zzz.bootstrap if built with bootstrap
499%bootstrap_release() %{!?with_bootstrap:%{1}%{?2:.%{2}}}%{?with_bootstrap:%{!?2:%(expr %{1} - 1)}%{?2:%{1}.%(expr %{2} - 1)}.zzz.bootstrap}
500
501# Requires name = version-release
502%requires_releq() %{!?1:ERROR}%{?2:ERROR}%{?1:%{!?2:%{expand:%%requires_eq_to -r %1 %1}}}
503# Requires: name = version
504%requires_eq() %{!?1:ERROR}%{?2:ERROR}%{?1:%{!?2:%{expand:%%requires_eq_to %1 %1}}}
505# Requires: name = version (version based on querying package %2)
506%requires_eq_to(r) %{!?2:ERROR}%{?3:ERROR}%{?2:%{!?3:%(if ! LC_ALL=C rpm -q --qf 'Requires: %1 = %|E?{%{E}:}|%{V}%{?-r:-%{R}}\\n' %2 | grep '^Requires:'; then echo "BuildRequires: %2"; fi)}}
507
508# Requires: name >= version
509%requires_ge() %{!?1:ERROR}%{?2:ERROR}%{?1:%{!?2:%{expand:%%requires_ge_to %1 %1}}}
510# Requires: name >= version (version based on querying package %2)
511%requires_ge_to(r) %{!?2:ERROR}%{?3:ERROR}%{?2:%{!?3:%(if ! LC_ALL=C rpm -q --qf 'Requires: %1 >= %|E?{%{E}:}|%{V}%{?-r:-%{R}}\\n' %2 | grep '^Requires:'; then echo "BuildRequires: %2"; fi)}}
512
513# helper for renaming packages
514# %rename old-package
515%rename() \
516Obsoletes: %{1} < %{?epoch:%{epoch}:}%{?version:%{version}}%{?release:-%{release}} \
517Provides: %{1} = %{?epoch:%{epoch}:}%{?version:%{version}}%{?release:-%{release}}
518
519%apache_modules_api %{expand:%%global apache_modules_api %(awk '/#define MODULE_MAGIC_NUMBER_MAJOR/ {print $3}' /usr/include/apache/ap_mmn.h 2>/dev/null || echo ERROR)}%apache_modules_api
520
521# sgml macros
522%xmlcat_add() /usr/bin/xmlcatalog --noout --add nextCatalog \"\" %1 /etc/xml/catalog ;
523%xmlcat_del() /usr/bin/xmlcatalog --noout --del %1 /etc/xml/catalog ;
524%xmlcat_add_rewrite /usr/bin/xmlcatalog --noout --add rewriteSystem
525%xmlcat_create() /usr/bin/xmlcatalog --noout --create %1 ;
526%sgmlcat_add() /usr/bin/install-catalog --add %1 %2 > /dev/null ;
527%sgmlcat_del() /usr/bin/install-catalog --remove %1 %2 > /dev/null ;
528%docbook_sgmlcat_fix() { for l in \
529'' \
530' -- default decl --' \
531'DTDDECL "-//OASIS//DTD DocBook XML V%2//EN" "../../xml.dcl"' \
532' -- hacks for opensp --' \
533'SYSTEM "file://%{_datadir}/sgml/docbook/xml-dtd-%2/docbookx.dtd" "%{_datadir}/sgml/docbook/xml-dtd-%2/docbookx.dtd"' \
534'SYSTEM "http://www.oasis-open.org/docbook/xml/%2/docbookx.dtd" "%{_datadir}/sgml/docbook/xml-dtd-%2/docbookx.dtd"' \
535'' \
536; do echo $l; done >> %1 \
537}
538
539# vim - "
540
541# minimum file size needed for compressed documents.
542# just smaller files than this get larger when compressed.
543# some stats:
544# - 0 byte file compressed was 25 bytes .gz
545# - 39 byte file was compressed as 57
546# - with test/test.spec@man 158 byte file was compressed also 158
547%_min_compress_bytes 159
548
549#-----------------------------------------------------------------
550# find and gzip all files in %{_mandir} and %{infodir}
551#
552# Requires: xargs, find
553#
554#%no_install_post_compress_docs 1
555%__spec_install_post_compress_docs { \
556%{!?no_install_post_compress_docs:__spec_install_post_compress_docs() { \
557 %{!?debug:set +x;} \
558 for i in /usr/share/man /usr/X11R6/man; do \
559 if [ -d "$RPM_BUILD_ROOT$i" ]; then \
560 echo "Compress man pages: $i"; \
561 find "$RPM_BUILD_ROOT$i" -name '*.bz2' -print0 | xargs -0 -r %{__bzip2} -df; \
562 find "$RPM_BUILD_ROOT$i" -name '*.gz' -print0 | xargs -0 -r %{__gzip} -dnf; \
563 find $RPM_BUILD_ROOT$i -type l | while read a; do \
564 m=$(readlink "$a"); \
565 if [[ "$m" = */* ]]; then \
566 # handle links to different man section \
567 l=$(readlink -f "$a"); \
568 # full/relative paths that resolve symlink \
569 l=${l#$RPM_BUILD_ROOT/usr/share/man/}; \
570 l=${l#$RPM_BUILD_ROOT/usr/X11R6/man/}; \
571 # full paths that do not resolve symlink \
572 l=${l#/usr/share/man/}; \
573 l=${l#/usr/X11R6/man/}; \
574 else \
575 l=${a#$RPM_BUILD_ROOT$i/}; \
576 l=${l%/*}; \
577 l="$l/$m"; \
578 fi; \
579 rm -f $a; \
580 echo ".so $l" > $a; \
581 echo >&2 "Converted ${a#$RPM_BUILD_ROOT} from symlink to man link: $l"; \
582 done; \
583 # verify that .so links point to existing files (not allowed to point to "other package") \
584 # TODO: iterate over all man dirs, but in Th there is only one true man dir \
585 err=$(grep -rl '^\.so ' "$RPM_BUILD_ROOT$i" | while read doc; do \
586 l=$(grep -r '^\.so ' "$doc"); \
587 l=${l#.so }; \
588 d=$(dirname $doc); \
589 test -e $RPM_BUILD_ROOT$i/$l || test -e $d/$(basename $l) || echo " ${doc#$RPM_BUILD_ROOT} points to inexistent manpage: $l"; \
590 done); \
591 test "$err" != "" && { echo >&2 "Man page link errors:"; echo >&2 "$err"; exit 1; }; \
592 find "$RPM_BUILD_ROOT$i" -type f -size +%{_min_compress_bytes}c -print0 | xargs -0 -r %{__gzip} -9nf; \
593 fi; \
594 done; \
595 if [ -d "$RPM_BUILD_ROOT%{_infodir}" ]; then \
596 echo "Compress info pages: %{_infodir}"; \
597 find "$RPM_BUILD_ROOT%{_infodir}" -name '*.bz2' -print0 | xargs -0 -r %{__bzip2} -df; \
598 find "$RPM_BUILD_ROOT%{_infodir}" -name '*.gz' -print0 | xargs -0 -r %{__gzip} -dnf; \
599 find "$RPM_BUILD_ROOT%{_infodir}" -name '*.info*' -type f -size +%{_min_compress_bytes}c -print0 | xargs -0 -r %{__gzip} -9nf; \
600 fi; \
601}; __spec_install_post_compress_docs } }
602
603#-----------------------------------------------------------------
604# Strip executable binaries and shared object files
605#
606# Requires: find, awk, strip, cut, xargs
607#
608# Special macros which affect this process:
609#%no_install_post_strip 1 # disable stripping at all
610#%_noautostrip regexp # exclude files matching (anchored!) regex from stripping
611#%_autostripall regexp # strip files matching (anchored!) regex using plain strip
612#%_autostripunneeded regexp # strip files matching (anchored!) regex using strip --strip-unneeded
613#%_autostripdebug regexp # strip files matching (anchored!) regex using strip --strip-debug
614#
615%__spec_install_post_strip {%{!?debug: \
616%{!?no_install_post_strip:__spec_install_post_strip() { \
617%{!?debug:set +x;} \
618if [ -d "$RPM_BUILD_ROOT" ]; then \
619 if [ -d $RPM_BUILD_ROOT/lib/modules ]; then \
620 modulelist=$(find $RPM_BUILD_ROOT/lib/modules \( -name '*.o' -o -name '*.ko' \) -type f -print); \
621 if [ "$modulelist" ]; then \
622 modulecount=$(echo "$modulelist" | wc -l); \
623 printf "Stripping %d kernel modules..." $modulecount; \
624 echo "$modulelist" | xargs -l512 chmod u+w; \
625 echo "$modulelist" | xargs -l512 %{__strip} -g --remove-section=.comment --remove-section=.note.GNU-stack; \
626 echo "DONE"; \
627 fi; \
628 fi; \
629 filelist=$(find $RPM_BUILD_ROOT -type f ! -regex ".*/usr/lib[x0-9]*/debug/.*\.debug" ! -regex ".*/usr/lib[x0-9]*.*/guile/.*\.go" ! -regex ".*/lib/modules/.*" ! -regex ".*%{_docdir}/.*" ! -regex ".*%{_includedir}/.*" %{?_noautostrip:! -regex "%{_noautostrip}"} %{?_autostripall:! -regex "%{_autostripall}"} %{?_autostripunneeded:! -regex "%{_autostripunneeded}"} %{?_autostripdebug:! -regex "%{_autostripdebug}"}); \
630 if [ -n "$filelist" ]; then \
631 filetypes=`echo "$filelist" | xargs -r -d'\\n' file`; \
632 elfexelist=`echo "$filetypes" | awk -F: '/ELF.*executable/ {print $1}'`; \
633 elfsharedlist=`echo "$filetypes" | awk -F: '/LF.*shared object/ {print $1}'`; \
634 archiveslist=`echo "$filetypes" | awk -F: '/current ar archive/ {print $1}'`; \
635 if [ -n "$elfexelist" ]; then \
636 printf "Stripping %d ELF executables..." $(echo "$elfexelist" | wc -l); \
637 echo "$elfexelist" | xargs -r -d'\n' chmod u+w; \
638 echo "$elfexelist" | xargs -r -d'\n' %{__strip} --remove-section=.note --remove-section=.comment; \
639 echo "DONE"; \
640 fi; \
641 if [ -n "$elfsharedlist" ]; then \
642 printf "Stripping %d ELF shared libraries..." $(echo "$elfsharedlist" | wc -l); \
643 echo "$elfsharedlist" | xargs -r -d'\n' chmod u+w; \
644 echo "$elfsharedlist" | xargs -r -d'\n' %{__strip} --strip-unneeded --remove-section=.note --remove-section=.comment; \
645 echo "DONE"; \
646 fi; \
647 if [ -n "$archiveslist" ]; then \
648 printf "Stripping %d ar archives..." $(echo "$archiveslist" | wc -l); \
649 echo "$archiveslist" | xargs -r -d'\n' chmod u+w; \
650 echo "$archiveslist" | xargs -r -d'\n' %{__strip} --strip-debug --remove-section=.note --remove-section=.comment; \
651 echo "DONE"; \
652 fi; \
653 fi; \
654 filelist_all=%{?_autostripall:$(find $RPM_BUILD_ROOT -type f -regex "%{_autostripall}")}; \
655 filelist_unneeded=%{?_autostripunneeded:$(find $RPM_BUILD_ROOT -type f -regex "%{_autostripunneeded}")}; \
656 filelist_debug=%{?_autostripdebug:$(find $RPM_BUILD_ROOT -type f -regex "%{_autostripdebug}")}; \
657 if [ -n "$filelist_all" ]; then \
658 printf "Stripping everything from %d additional files..." $(echo "$filelist_all" | wc -l); \
659 chmod u+w $filelist_all; \
660 %{__strip} --remove-section=.note --remove-section=.comment $filelist_all; \
661 echo "DONE"; \
662 fi; \
663 if [ -n "$filelist_unneeded" ]; then \
664 printf "Stripping unneeded from %d additional files..." $(echo "$filelist_unneeded" | wc -l); \
665 chmod u+w $filelist_unneeded; \
666 %{__strip} --strip-unneeded --remove-section=.note --remove-section=.comment $filelist_unneeded; \
667 echo "DONE"; \
668 fi; \
669 if [ -n "$filelist_debug" ]; then \
670 printf "Stripping debuginfo from %d additional files..." $(echo "$filelist_debug" | wc -l); \
671 chmod u+w $filelist_debug; \
672 %{__strip} --strip-debug --remove-section=.note --remove-section=.comment $filelist_debug; \
673 echo "DONE"; \
674 fi; \
675fi; }; __spec_install_post_strip } } }
676
677#-----------------------------------------------------------------
678# remove all RPATH/RUNPATH from executable binaries and shared object files
679#
680# Requires: find, awk, cut, xargs, chrpath, uname
681#
682# Special macros which affect this process
683#%no_install_post_chrpath 1 # disable chrpath at all
684#%_noautochrpath regex # exclude files matching (anchored!) regex from chrpath
685#
686%__spec_install_post_chrpath {%{!?debug: \
687%{!?no_install_post_chrpath: __spec_install_post_chrpath() { \
688%{!?debug:set +x;} \
689if [ -d "$RPM_BUILD_ROOT" ]; then \
690 files=`find $RPM_BUILD_ROOT -type f ! -regex ".*ld-[0-9.]*so.*" ! -regex ".*/usr/lib[0-9]*/debug/.*" ! -regex ".*/lib/modules/.*" ! -regex ".*%{_docdir}/.*" ! -regex ".*%{_includedir}/.*" %{?_noautochrpath:! -regex "%{_noautochrpath}"}`; \
691 if [ -n "$files" ]; then \
692 objs=`echo "$files" | xargs -r -d'\\n' file | awk -F: '/ELF.*(executable.*dynamically linked|shared object)/ {print $1}'`; \
693 fi; \
694 if [ -n "$objs" ]; then \
695 printf "Remove RPATH/RUNPATH from %d executable binaries and shared object files.\n" $(echo "$objs" | wc -l); \
696 echo "$objs" | \
697 while read file; do \
698 rpath= ; \
699 chmod u+w "$file"; \
700 for dir in $(chrpath -l "$file" | awk '/(R|RUN)PATH=/ { gsub(/.*RPATH=/,""); gsub(/.*RUNPATH=/,""); gsub(/:/," "); print $0 }'); do \
701 case $dir in \
702 '$ORIGIN' ) \
703 if [ "$rpath" = "" ] ; then rpath="$dir" ; \
704 else rpath="$rpath:$dir" ; fi ; \
705 continue ; \
706 ;; \
707 esac ; \
708 newdir=$(readlink -m "$dir"); \
709 [ ${#newdir} -le ${#dir} ] && dir=$newdir; \
710 case $dir in \
711 /home/* | /tmp/* | /usr/lib | /usr/lib64 | /lib | /lib64 | /usr/local/lib | /usr/local/lib64 | /usr/X11R6/lib | /usr/X11R6/lib64 ) \
712 echo "remove-rpath: $dir in $file"; \
713 ;; \
714 * ) \
715 if [ "$rpath" = "" ] ; then rpath="$dir" ; \
716 else rpath="$rpath:$dir" ; fi ; \
717 ;; \
718 esac ; \
719 done ; \
720 if [ "$rpath" = "" ] ; then chrpath -d "$file" > /dev/null ; \
721 else chrpath -r "$rpath" "$file" > /dev/null ; fi ; \
722 done; \
723 fi; \
724fi; }; __spec_install_post_chrpath } } }
725
726# vim: "
727
728#-----------------------------------------------------------------
729# Find all shared object files with unresolved symbols. Warn
730# and terminate if any found (termination can be turned off by define).
731#%no_install_post_check_so 1
732#%skip_post_check_so libwithunresolvedok.so.*
733#
734# NOTE: define skip_post_check_so only if such library really requires
735# unresolved symbols and always leave a comment why it is required:
736# # executable provides symbols foo, bar for those libraries:
737# %define skip_post_check_so libwithoutfoo.so.* libwithoutbar.so.*
738#
739%__spec_install_post_check_so { \
740__spec_install_post_check_so() { \
741%{!?debug:set +x;} \
742 fail=0; \
743 printf "Searching for shared objects with unresolved symbols..."; \
744 for f in $(find $RPM_BUILD_ROOT -type f -name '*.so.*' -print); do \
745 LC_ALL=C objdump -T $f 2> /dev/null | LC_ALL=C awk -v "file=$f" 'BEGIN { found=0; skip["program_name"]=1; skip["_ZSt15__once_callable"]=1; skip["_ZSt11__once_call"]=1; symbols = "" } /^[0-9a-z]+ +D +\*UND\*/ { if ($NF in skip) { next; }; found = 1; symbols = symbols "\n\t" $NF } END { if (found) { print "\nUnresolved symbols found in: " file symbols; %{?skip_post_check_so:split("%{skip_post_check_so}", R); for (i=1; i in R; i++) { if (file ~ "(^|/)" R[i] "$") { print "Library marked with skip_post_check_so, ignoring errors.\n"; exit(0); } } } exit(1); } } ' || fail=1 ; \
746 done ; \
747 echo " DONE"; \
748 %{!?no_install_post_check_so:return $fail;} \
749}; __spec_install_post_check_so }}
750
751#-----------------------------------------------------------------
752# Find all ELF files with executable stac. Warn and terminate if any found
753# (termination can be turned off by define).
754# Details: https://wiki.gentoo.org/wiki/Hardened/GNU_stack_quickstart
755#%no_install_post_check_stackexec 1
756#%skip_post_check_stackexec libwithexecstackok.so.*
757#
758# NOTE: define skip_post_check_stackexec only if such program or library
759# really requires executable stack and always leave a comment why
760# it is required:
761# # Programs full of nested functions that cannot be fixed
762# %define skip_post_check_execstack /bin/foo libwithexecstack.so.*
763#
764%__spec_install_post_check_execstack { \
765__spec_install_post_check_execstack() { \
766%{!?debug:set +x;} \
767 fail=0; \
768 printf "Searching for ELF programs with executable stack..."; \
769 for f in $(find $RPM_BUILD_ROOT -type f -print) ; do \
770 LC_ALL=C readelf -lW $f 2>/dev/null | \
771 LC_ALL=C awk -v "file=$f" 'BEGIN { found=0; } /GNU_STACK/ { if ($7 ~ "E") { found=1 } } END { if (found) { print "\nExecutable stack found in: " file; %{?skip_post_check_execstack:split("%{skip_post_check_execstack}", R); for (i=1; i in R; i++) { if (file ~ "(^|/)" R[i] "$") { print "File marked with skip_post_check_execstack, ignoring errors.\n"; exit(0); } } } exit(1); } }' || fail=1 ; \
772 done ; \
773 echo " DONE"; \
774 %{!?no_install_post_check_execstack:return $fail;} \
775}; __spec_install_post_check_execstack }}
776
777#-----------------------------------------------------------------
778# Verify that for each directory under /var/run package contains
779# tmpfiles.d configuration. Warn and terminate build if config is
780# missing.
781#
782#%no_install_post_check_tmpfiles 1
783#
784%__spec_install_post_check_tmpfiles { \
785__spec_install_post_check_tmpfiles() { \
786%{!?debug:set +x;} \
787 fail=0; \
788 echo "Checking /var/run <-> tmpfiles.d completeness..."; \
789 for d in $RPM_BUILD_ROOT/var/run/*; do \
790 [ -d "$d" ] || continue; \
791 d=${d##$RPM_BUILD_ROOT}; \
792 if ! grep -qsF "$d" $RPM_BUILD_ROOT/usr/lib/tmpfiles.d/*.conf $RPM_BUILD_ROOT/etc/tmpfiles.d/*.conf; then\
793 echo "No tmpfiles configuration for '$d'";\
794 fail=1 ; \
795 fi \
796 done ; \
797 echo " DONE"; \
798 %{!?no_install_post_check_tmpfiles:return $fail;} \
799}; __spec_install_post_check_tmpfiles }}
800
801#-----------------------------------------------------------------
802# Verify that scripts have reasonable shebangs
803# Test spec: see "test/spec_install_post_check_shebangs" branch on packages/test.spec
804#
805#%no_install_post_check_shebangs 1
806#
807%__spec_install_post_check_shebangs { \
808__spec_install_post_check_shebangs() { \
809%{!?debug:set +x;} \
810 fail=0; \
811 echo "Checking script shebangs..."; \
812 for f in $(find $RPM_BUILD_ROOT -type f -perm -500 -print); do \
813 shebang="$(sed -e'1s/#! *\(.*\)/\1/;t;d;q' "$f")" ; \
814 f="${f##$RPM_BUILD_ROOT}"; \
815 case "$shebang" in \
816 "%{__python}"|"%{__python3}"|"%{__python} "*|"%{__python3} "* \
817 |"/usr/bin/python%{py_ver}"|"/usr/bin/python%{py_ver} "* \
818 |"/usr/bin/python%{py3_ver}"|"/usr/bin/python%{py3_ver} "*) \
819 ;; \
820 "/usr/bin/env python"*|"/usr/bin/python"|"/usr/bin/python "*) \
821 echo "$f starts with '#!$shebang', should be '#!%{__python}' or '#!%{__python3}'" >&2;\
822 fail=1 ; \
823 ;; \
824 "/usr/bin/env "*) \
825 echo "$f starts with '#!$shebang', should be explicit interpreter path" >&2;\
826 fail=1 ; \
827 ;; \
828 *) ;;\
829 esac ; \
830 done ; \
831 echo " DONE" ; \
832 %{!?no_install_post_check_shebangs:return $fail;} \
833}; __spec_install_post_check_shebangs }}
834
835# Remove common Perl files we don't package
836%__spec_install_post_perl_clean {\
837%{!?no_install_post_perl_clean: \
838%{?pdir:rm -f $RPM_BUILD_ROOT{%{perl_archlib}/perllocal.pod,%{perl_vendorarch}/auto/%{pdir}%{?pnam:/%(echo %{pnam} | tr - /)}/.packlist}} \
839} }
840
841# Helpers to specify SONAME depdendencies, e.g.:
842# Requires: %{_soname_prov libfoo.so.1}
843# Requires: %{_soname_prov libfoo.so.1(SOME_SYMVER)}
844#
845# BuildRequires: rpmbuild(macros) >= 1.721
846#
847%_soname_tag %(echo %{_lib} | sed -e 's/^lib//' -e 's/^\\(.\\+\\)$/(\\1bit)/')
848%_soname_prov() %(echo "%{1}()%{_soname_tag}" | sed -e 's/^\\([^(]*([^)]\\+)\\)()%{_soname_tag}$/\\1%{_soname_tag}/;s/()$//')
849
850#-----------------------------------------------------------------
851# Update GConf2 schemas
852#
853# Requires: GConf2
854#
855%gconf_schema_install() \
856 umask 022; \
857 GCONF_CONFIG_SOURCE="xml:readwrite:/etc/gconf/gconf.xml.defaults" \\\
858 /usr/bin/gconftool-2 --makefile-install-rule /etc/gconf/schemas/%{?1}%{!?1:*.schemas} > /dev/null; \
859%{nil}
860
861%gconf_schema_uninstall() \
862if [ $1 = 0 -a -x /usr/bin/gconftool-2 ]; then \
863 umask 022; \
864 GCONF_CONFIG_SOURCE="xml:readwrite:/etc/gconf/gconf.xml.defaults" \\\
865 /usr/bin/gconftool-2 --makefile-uninstall-rule /etc/gconf/schemas/%{?1} > /dev/null \
866fi; \
867%{nil}
868
869#-----------------------------------------------------------------
870# Update desktop MIME database
871# requires: desktop-file-utils
872%update_desktop_database() {{ \
873 umask 022; \
874 /usr/bin/update-desktop-database -q; \
875};} \
876%{nil}
877
878%update_desktop_database_post %update_desktop_database
879
880%update_desktop_database_postun() {{ \
881if [ "$1" = "0" ]; then \
882 %update_desktop_database \
883fi; \
884};} \
885%{nil}
886
887#-----------------------------------------------------------------
888# Update shared MIME info database
889# requires: shared-mime-info
890# Note: https://bugs.freedesktop.org/show_bug.cgi?id=70366#c19
891# https://bugzilla.redhat.com/show_bug.cgi?id=1052173
892# TODO: if you want this running with fdatasync(), make sure it's:
893# 1. announcing ~minute delay by echoing appropriate message,
894# 2. running only once after rpm transaction.
895#
896%update_mime_database() {{ \
897 umask 022; \
898 PKGSYSTEM_ENABLE_FSYNC=0 \
899 /usr/bin/update-mime-database %{_datadir}/mime; \
900};} \
901%{nil}
902
903#-----------------------------------------------------------------
904# Update icon cache
905# BuildRequires: rpmbuild(macros) >= 1.596
906# Requires: hicolor-icon-theme
907#
908%update_icon_cache() {{ \
909 %{!?1:%{error:%{0}: Required theme name missing}} \
910 if [ -x /usr/bin/gtk-update-icon-cache ]; then \
911 umask 022; \
912 touch --no-create %{_iconsdir}/%1; \
913 /usr/bin/gtk-update-icon-cache -qf %{_iconsdir}/%1; \
914 fi; \
915};} \
916%{nil}
917
918#-----------------------------------------------------------------
919# Update scrollkeeper database
920# requires: scrollkeeper
921#
922%scrollkeeper_update_post() \
923 /usr/bin/scrollkeeper-update -q; \
924%{nil}
925
926%scrollkeeper_update_postun() \
927if [ "$1" = "0" ]; then \
928 /usr/bin/scrollkeeper-update -q; \
929fi; \
930%{nil}
931
932#-----------------------------------------------------------------
933# Compile GSettings schemas
934# requires: glib2 >= 1:2.26.0
935#
936%glib_compile_schemas() {{ \
937 umask 022; \
938 /usr/bin/glib-compile-schemas %{_datadir}/glib-2.0/schemas; \
939};} \
940%{nil}
941
942#-----------------------------------------------------------------
943# post %install sequence:
944# - autodeps exceptions
945# - compress all man and info pages,
946# - strip all ELF executables and ELF shared objects if not %debug.
947# - compress kernel modules if any
948
949###################################################################
950# Requires/Provides automation
951# exceptions system by Jacek Konieczny <jajcus@pld-linux.org>
952#
953%__noautoreqfiles %(sed -e s'/#.*//' /etc/rpm/noautoreqfiles)%{?_noautoreqfiles: %{_noautoreqfiles}}
954%__noautoprovfiles %(sed -e s'/#.*//' /etc/rpm/noautoprovfiles)%{?_noautoprovfiles: %{_noautoprovfiles}}
955%__noautoreqdep %(sed -e s'/#.*//' /etc/rpm/noautoreqdep)%{?_noautoreqdep: %{_noautoreqdep}}
956%__noautoprov %(sed -e s'/#.*//' /etc/rpm/noautoprov) \
957 %{?_noautoprov: %{_noautoprov}} \
958 %{?_noautoprov_java: %{__noauto_regexp_helper -p java %{_noautoprov_java}}} \
959 %{?_noautoprov_mono: %{__noauto_regexp_helper -p mono %{_noautoprov_mono}}} \
960 %{?_noautoprov_pear: %{__noauto_regexp_helper -p pear %{_noautoprov_pear}}} \
961 %{?_noautoprov_perl: %{__noauto_regexp_helper -p perl %{_noautoprov_perl}}} \
962 %{?_noautoprov_pyegg: %{__noauto_regexp_helper -p pythonegg %{_noautoprov_pyegg}}} \
963 %{?_noautoprov_py3egg: %{__noauto_regexp_helper -p python3egg %{_noautoprov_py3egg}}} \
964 %{nil}
965%__noautoreq %(sed -e s'/#.*//' /etc/rpm/noautoreq) \
966 %{?_noautoreq: %{_noautoreq}} \
967 %{?_noautoreq_java: %{__noauto_regexp_helper -p java %{_noautoreq_java}}} \
968 %{?_noautoreq_mono: %{__noauto_regexp_helper -p mono %{_noautoreq_mono}}} \
969 %{?_noautoreq_pear: %{__noauto_regexp_helper -p pear %{_noautoreq_pear}}} \
970 %{?_noautoreq_perl: %{__noauto_regexp_helper -p perl %{_noautoreq_perl}}} \
971 %{?_noautoreq_pyegg: %{__noauto_regexp_helper -p pythonegg %{_noautoreq_pyegg}}} \
972 %{?_noautoreq_py3egg: %{__noauto_regexp_helper -p python3egg %{_noautoreq_py3egg}}} \
973 %{nil}
974
975# helper for wrapping _noautoreq between perl() or pear()
976# Author: Elan Ruusamäe <glen@pld-linux.org>
977# Usage:
978# BuildRequires: rpmbuild(macros) >= 1.654
979# %define _noautoreq_pear Excluded.php PEAR/Something.php
980# %define _noautoreq_perl Apache::.*
981# BuildRequires: rpmbuild(macros) >= 1.672
982# %define _noautoreq_java ClassDataVersion
983# BuildRequires: rpmbuild(macros) >= 1.709
984# %define _noautoreq_pyegg argparse
985# %define _noautoreq_py3egg backports.ssl-match-hostname ipaddress
986# BuildRequires: rpmbuild(macros) >= 1.730
987# %define _noautoreq_mono Gendarme.Framework
988# BuildRequires: rpmbuild(macros) >= 1.737
989# %define _noautoprov_java Class
990# %define _noautoprov_mono Excluded.Provide
991# %define _noautoprov_pear Excluded.php
992# %define _noautoprov_perl Excluded::Module
993# %define _noautoprov_pyegg excluded
994# %define _noautoprov_py3egg excluded3
995#
996%__noauto_regexp_helper(p:) %(echo "%*" | awk 'BEGIN{RS=" "}{printf("%{-p*}%{__qchar}(%%s%{__qchar}) ", $1)}')
997# detect quote character runtime
998%__qchar_4 \\\\%{nil}
999%__qchar_5 \\\\\\%{nil}
1000%__qchar %{expand:%%global __qchar %%__qchar_%(echo %{_rpmversion} | cut -c1)}%__qchar
1001
1002#%_noautocompressdoc %{nil}
1003#
1004%_missing_doc_files_terminate_build 1%{nil}
1005%_unpackaged_files_terminate_build %{nil}
1006
1007# node.js libdir
1008# Requirements:
1009# BuildRequires: rpmbuild(macros) >= 1.634
1010%nodejs_libdir /usr/lib/node_modules
1011
1012# bash-completion 2.0 completions dir
1013# Requirements:
1014# BuildRequires: rpmbuild(macros) >= 1.673
1015# Requires: bash-completion >= 2.0
1016%bash_compdir /usr/share/bash-completion/completions
1017
1018# fish completions dir
1019# Requirements:
1020# BuildRequires: rpmbuild(macros) >= 1.720
1021%fish_compdir /usr/share/fish/vendor_completions.d
1022
1023# zsh completions dir
1024# Requirements:
1025# BuildRequires: rpmbuild(macros) >= 1.719
1026%zsh_compdir /usr/share/zsh/site-functions
1027
1028# depmod macro
1029%depmod() { \
1030umask 022; \
1031if [ -e /boot/System.map-%1 ]; then \
1032 /sbin/depmod -a -F /boot/System.map-%1 %1; \
1033else \
1034 if [ -e /boot/System.map ]; then \
1035 /sbin/depmod -a -F /boot/System.map %1; \
1036 else \
1037 /sbin/depmod -a %1; \
1038 fi \
1039fi; \
1040}
1041
1042# user/group checking macros
1043#
1044# Usage:
1045# %userremove myuser
1046#
1047%userremove /usr/lib/rpm/user_group.sh user del
1048%groupremove /usr/lib/rpm/user_group.sh group del
1049#
1050# Usage:
1051# if %usertestrm myuser; then
1052# /usr/sbin/userdel -r myuser
1053# Note:
1054# use these macros only if you need to call userdel/groupdel with
1055# a non-standard option or take an extra action; otherwise use the
1056# %userremove/%groupremove macros
1057#
1058%usertestrm /usr/lib/rpm/user_group.sh user testrm
1059%grouptestrm /usr/lib/rpm/user_group.sh group testrm
1060# user group membership management macros
1061#
1062# Usage:
1063# %addusertogroup [-q] myuser agroup
1064#
1065# -q if user or group don't exist, don't make big noise of it (MISSINGOK behaviour)
1066#
1067# Requirements:
1068# BuildRequires: rpmbuild(macros) >= 1.515
1069%addusertogroup(q) quiet=%{-q:1} /usr/lib/rpm/user_group.sh user addtogroup %*; \
1070%{nil}
1071
1072# banner support (useful in {pre,post}{,un} and triggers)
1073#
1074# Usage:
1075# %banner name [-a] [-e] [-n] [-tn] [-o] <<EOF
1076# the banner text, the banner text
1077# the banner text, and following line
1078#EOF
1079# You can use any form of here-document, <<'EOF' <<-EOT will do.
1080# NOTE: if your use "<<-EOF", then You can actually indent inside here-document.
1081#
1082# -a - append to the banner
1083# -e - send to stderr instead of stdout
1084# -n - don't show banner (overrides -t)
1085# -t - show only, if RPM_SCRIPTVERBOSITY >= n; default n=5
1086# -o - show only once, i.e when package is installed for the first time
1087#
1088# Tests:
1089# (rpm -E '%banner -e banner <<EOF'; echo -e 'hi\nEOF') > m; sh -x m
1090# (rpm -E '%banner -o -e banner <<EOF'; echo -e 'hi\nEOF') > m; sh -x m
1091# (rpm -E '%banner -o -e banner <<EOF'; echo -e 'hi\nEOF') > m; sh -x m 1
1092# rpm -E 'date | %banner -e banner' > m; sh -x m
1093# rpm -E 'date | %banner -o -e banner' > m; sh -x m
1094#
1095%banner(aenot:) %{-o:([ "$1" != 1 ] ||} ( \
1096RPM_SCRIPTVERBOSITY=5 \
1097[ -r /etc/sysconfig/rpm ] && . /etc/sysconfig/rpm \
1098if [ -x /usr/bin/banner.sh ]; then \
1099 CMD="/usr/bin/banner.sh %{-e:--stderr} %{!-n:$([ $RPM_SCRIPTVERBOSITY -ge %{-t:%{-t*}}%{!-t:5} ] && echo -s)} %{!-a:-m}%{-a:-M} %1" \
1100else \
1101 CMD="cat%{-e: >&2}" \
1102fi \
1103eval $CMD %{?2:%2}%{?3: %3})%{-o:)} \
1104%{nil}
1105
1106# useradd/groupadd macros
1107# Author: Elan Ruusamäe <glen@pld-linux.org>
1108#
1109# Usage:
1110# %useradd [-P package] [-u uid] [-d home_dir] [-s shell] [-c comment]
1111# [-g initial_group] [-G group[,...]] login
1112#
1113# -u uid. REQUIRED
1114# -g gid/group. REQUIRED
1115# -s defaults to /bin/false
1116# -d defaults to /usr/share/empty
1117# -c No default
1118# -r is accepted but ignored (it's always set)
1119# -k skeleton dir. defaults to /usr/share/empty
1120# rpm specific flags
1121# -P package name. defaults to %{name}
1122#
1123%useradd(c:d:e:f:g:G:Mmk:op:s:u:rP:) \
1124%{!-u:%{error:useradd: Required argument -u missing}} \
1125%{!-g:%{error:useradd: Required argument -g missing}} \
1126%{!?1:%{error:useradd: Required parameter login missing}} \
1127if [ -n "`/bin/id -u %{expand:%{%{#}}} 2>/dev/null`" ]; then \
1128 if [ "`/bin/id -u %{expand:%{%{#}}}`" != "%{-u*}" ]; then \
1129 echo "Error: user %{expand:%{%{#}}} doesn't have uid=%{-u*}. Correct this before installing %{-P*}%{!?-P:%{name}}." 1>&2 \
1130 exit 1 \
1131 fi \
1132else \
1133 echo "Adding user %{expand:%{%{#}}} UID=%{-u*}." \
1134 /usr/sbin/useradd \\\
1135 %{-m:-m -k %{-k*}%{!-k:/usr/share/empty}} \\\
1136 -u %{-u*} \\\
1137 -r \\\
1138 -d %{-d*}%{!-d:/usr/share/empty} \\\
1139 -s %{-s*}%{!-s:/bin/false} \\\
1140 %{-c:-c "%(set -- %{-c*} %{*}; echo $1)"}\\\
1141 -g %{-g*} \\\
1142 %{-M} \\\
1143 %{-G:-G %{-G*}} \\\
1144 %{expand:%{%{#}}} 1>&2 || exit $? \
1145 [ ! -x /usr/sbin/nscd ] || /usr/sbin/nscd -i passwd || : \
1146fi;
1147# vim: "
1148
1149# Usage:
1150# %groupadd [-P package] [-g gid] group
1151#
1152# -g gid. REQUIRED
1153#
1154# Sample:
1155# %groupadd -P %{name}-base -g %{gid} %{name}
1156
1157%groupadd(g:P:rfo) \
1158%{!-g:%{error:groupadd: Required argument -g missing}} \
1159%{!?1:%{error:groupadd: Required parameter group missing}} \
1160if /usr/bin/getgid %{1} > /dev/null 2>&1; then \
1161 if [ "`/usr/bin/getgid %{1}`" != "%{-g*}" ]; then \
1162 echo "Error: group %{1} doesn't have gid=%{-g*}. Correct this before installing %{-P*}%{!?-P:%{name}}." 1>&2 \
1163 exit 1 \
1164 fi \
1165else \
1166 echo "Adding group %{1} GID=%{-g*}." \
1167 /usr/sbin/groupadd -g %{-g*} -r %{1} 1>&2 || exit $? \
1168 [ ! -x /usr/sbin/nscd ] || /usr/sbin/nscd -i group || : \
1169fi;
1170
1171# service macro.
1172# Author: Elan Ruusamäe <glen@pld-linux.org>
1173#
1174# calls usual service restart on package %post, but skips the restart if
1175# administrator has disabled automatic service restarts in either global
1176# /etc/sysconfig/rpm or per service /etc/sysconfig/SERVICE file.
1177# NOTE: systemd_booted machines do not print
1178# Run "{command}" to restart {service}.
1179# message for packages without native systemd unit (not here, no %systemd_post).
1180#
1181# Usage:
1182# %service [-q] [-n] SERVICE ACTION ["SERVICE NICE DESCRIPTION"]
1183#
1184# -q be silent when service isn't started (for scriplets restaring other package's services)
1185# -n NOOP mode, do not actually restart service
1186#
1187# Requirements:
1188# BuildRequires: rpmbuild(macros) >= 1.268
1189# Requires: rc-scripts
1190# -n option:
1191# BuildRequires: rpmbuild(macros) >= 1.450
1192%service(qn) {{%(export noop=%{-n:1} quiet=%{-q:1} RPM_BUILD_ROOT=%{buildroot}; /usr/lib/rpm/service_generator.sh %{*}) };}
1193
1194%env_update [ ! -x /sbin/env-update ] || /sbin/env-update -u || :
1195
1196# patchset macros
1197# generate SourceX urls from range START STOP
1198# Format can be SINGLE format char of %e, %f, %g, see seq(1)
1199# The sources start from 10000
1200#
1201# Author: Elan Ruusamäe <glen@pld-linux.org>
1202#
1203# Usage:
1204# %patchset_source -f <seq(1) format> <start> [<end>]
1205# %patchset_patch <start> [<end>]
1206# If <end> is omited, it is assumed to be <start>.
1207#
1208# For example in preamble:
1209# %patchset_source -f ftp://ftp.vim.org/pub/editors/vim/patches/7.0/7.0.%03g 33 44
1210# and in %prep:
1211# %patchset_patch 33 44
1212#
1213# Using sources list:
1214# BuildRequires: rpmbuild(macros) >= 1.426
1215# %patchset_source -f <url> -s <filelist>
1216# %patchset_patch -s <filelist>
1217# For example (ncurses):
1218# BuildRequires: rpmbuild(macros) >= 1.683
1219# %patchset_source -f ftp://dickey.his.com/ncurses/%{basever}/ -s sources
1220# %patchset_patch -s sources -p1
1221#
1222
1223%patchset_source(f:b:s:) %(
1224 base=%{-b*}%{!-b*:10000}
1225%{-s:
1226 baseurl='%{-f*}'
1227 filelist='%{-s*}'
1228 i=$base
1229 while read checksum file; do
1230 printf "Patch%d: %s%s\\n" $i "$baseurl" "$file"
1231 i=$((i+1))
1232 done < $filelist
1233}
1234%{!-s:
1235 start=$(expr $base + %1);
1236 end=$(expr $base + %{?2}%{!?2:%{1}});
1237 # we need to call seq twice as it doesn't allow two formats
1238 seq -f 'Patch%g:' $start $end > %{tmpdir}/__ps1;
1239 seq -f '%{-f*}' %1 %{?2}%{!?2:%{1}} > %{tmpdir}/__ps2;
1240 paste %{tmpdir}/__ps{1,2};
1241 rm -f %{tmpdir}/__ps{1,2};
1242}
1243) \
1244%{nil}
1245
1246# apply sources from %patchset_source
1247# -p specify -pX for %patch line
1248# -b base offset: defaults to 10000
1249# -s filelist to read files from
1250%patchset_patch(f:p:b:s:) %(
1251 base=%{-b*}%{!-b*:10000}
1252 patchlevel=%{-p*:-p%{-p*}}
1253%{-s:
1254 filelist='%{-s*}'
1255 i=$base
1256 while read checksum file; do
1257 printf "patch%d %s\\n" $i "$patchlevel" | sed -e s,^,%%,
1258 i=$((i+1))
1259 done < $filelist
1260}
1261%{!-s:
1262 start=$(expr $base + %1);
1263 end=$(expr $base + %{?2}%{!?2:%{1}});
1264 echo ": patchset_patch %1%{?2: to %2}";
1265 seq -f "patch%g $patchlevel" $start $end | sed -e s,^,%%,;
1266}
1267) \
1268%{nil}
1269
1270# return EXPANDED source url N from current spec
1271%sourceurl(n:) %(test "$IN_RPM" = 1 && exit 1; export IN_RPM=1; rpmbuild --nodigest --nosignature --nobuild -D "prep %%dump" %{_specdir}/%{name}.spec 2>&1 | awk '$2 ~ /^SOURCEURL%{-n*}/ {print $3}')
1272
1273# Helper for LUA.
1274# split string separated by space into quoted list
1275#
1276# Author: Elan Ruusamäe <glen@pld-linux.org>
1277#
1278# %__lua_split /bin/sh /bin/pdksh -> "/bin/sh", "/bin/pdksh"
1279%__lua_split() %(echo "%*" | awk '{for (i=1;i<=NF;i++) printf("\\"%%s\\"%%s", $i, i == NF ? "" : ", ")}')
1280
1281# adjust /etc/shells by adding and removing shells from there
1282# Author: Elan Ruusamäe <glen@pld-linux.org>
1283#
1284# Usage:
1285# %post -p <lua>
1286# %lua_add_etc_shells /bin/sh /bin/pdksh
1287#
1288# %preun -p <lua>
1289# if arg[2] == 0 then
1290# %lua_remove_etc_shells /bin/bash /bin/rbash
1291# end
1292#
1293# Requirements:
1294# BuildRequires: rpmbuild(macros) >= 1.462
1295#
1296
1297%lua_add_etc_shells() \
1298t = {}\
1299f = io.open("/etc/shells", "r")\
1300if f then\
1301 for l in f:lines() do t[l]=l; end\
1302 f:close()\
1303end\
1304for _, s in ipairs({%{expand:%%__lua_split %*}}) do\
1305 if not t[s] then\
1306 print("Adding "..s.." to /etc/shells")\
1307 f = io.open("/etc/shells", "a")\
1308 if f then\
1309 f:write(s.."\\n")\
1310 f:close()\
1311 end\
1312 end\
1313end\
1314%{nil}
1315
1316%lua_remove_etc_shells() \
1317t = {}\
1318f = io.open("/etc/shells", "r")\
1319if f then\
1320 for l in f:lines() do t[l]=l; end\
1321 f:close()\
1322end\
1323for _, l in pairs({%{expand:%%__lua_split %*}}) do\
1324 print("Removing "..l.." from /etc/shells")\
1325 t[l] = nil\
1326end\
1327s=""\
1328for _, l in pairs(t) do\
1329 s=s..l.."\\n"\
1330end\
1331f = io.open("/etc/shells", "w")\
1332if f then\
1333 f:write(s)\
1334 f:close()\
1335end\
1336%{nil}
1337
1338# Backwards compat. Use of %lua_ prefixed macros is preferred as these are cleaner to read.
1339#
1340# Author: Elan Ruusamäe <glen@pld-linux.org>
1341#
1342# Usage:
1343# %post -p %add_etc_shells -p /bin/sh /bin/pdksh
1344# %preun -p %remove_etc_shells -p /bin/sh /bin/pdksh
1345#
1346# -p (optional) -- specifies that result is embeded %post script (prepends <lua> as first line)
1347#
1348# Requirements:
1349# BuildRequires: rpmbuild(macros) >= 1.429
1350#
1351%add_etc_shells(p) %{-p:<lua>}\
1352%{expand:%%lua_add_etc_shells %*}\
1353%{nil}
1354
1355%remove_etc_shells(p) %{-p:<lua>}\
1356%{-p:if arg[2] == 0 then}\
1357%{expand:%%lua_remove_etc_shells %*}\
1358%{-p:end} \
1359%{nil}
1360
1361# Undos files
1362#
1363# Author: Paweł Zuzelski <pawelz@pld-linux.org>
1364# Author: Elan Ruusamäe <glen@pld-linux.org>
1365#
1366# Usage:
1367# %undos list_of_files
1368# %undos -f EXT[,EXT]
1369# %undos -i -f EXT[,EXT]
1370#
1371# -f EXT[,EXT] - find(1) files by extensions
1372# -i - case insensitive file search
1373#
1374# Example:
1375# Un-DOS all *.js, *.css files
1376# %undos -f js,css
1377# Un-DOS all *.js, *.JS files
1378# %undos -f js -i
1379# undos all Makefiles
1380# %{__find} -name Makefile | xargs %undos
1381#
1382# Requirements:
1383# BuildRequires: sed >= 4.0
1384# BuildRequires: rpmbuild(macros) >= 1.674
1385
1386# NB: make sure this macro stays on one line
1387# NB: make sure it includes newline escape
1388%undos(f:i) %{-f:%{__find} -type f -regextype posix-extended -%{-i:i}regex '^.+\\.(%(echo %{-f*} | tr ',' '|'))$' -print0 | xargs -0} %{__sed} -i -e 's,\\r$,,' %* \
1389%{nil}
1390
1391#-----------------------------------------------------------------
1392# Update hardware database index
1393#
1394# Requirements:
1395# BuildRequires: rpmbuild(macros) >= 1.691
1396# Requires: udev-core >= 1:196
1397
1398%udev_hwdb_update() \
1399/sbin/udevadm hwdb --update >/dev/null 2>&1 || : \
1400%{nil}
1401
1402# Generate vim help tags file
1403#
1404# Requirements:
1405# BuildRequires: rpmbuild(macros) >= 1.718
1406# Requires(post,postun): /usr/bin/vim
1407# Requires(post,postun): vim-rt >= 4:7.4.2054-2
1408%vim_doc_helptags() \
1409umask 022; \
1410/usr/bin/vim -c ':helptags /usr/share/vim/doc' -c ':q' 2>/dev/null \
1411%{nil}
1412
1413# EOF
This page took 0.151354 seconds and 4 git commands to generate.